﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace PictureMemoSystem001
{
    public delegate void TextboxTextChangedEventDelegate(string newString, int ss);

    public partial class FormPMS : Form
    {
        private event TextboxTextChangedEventDelegate TextboxTextChangedEvent;

        const string SubFolder = "usedbypms";
        const string OrderTextFileName = "order.utf8.txt";

        const string Layer2Ex = ".2.png";
        const string Layer3Ex = ".3.png";
        const string MemoTextEx = ".utf8.txt";

        const string FontSettingTextboxFileName = "fontsettingtextbox.utf8.txt";
        const string FontSettingListboxFileName = "fontsettinglistbox.utf8.txt";

        const string HistoryFileName = "history.utf8.txt";

        Encoding USE_ENCODING = Encoding.GetEncoding("utf-8");
        string[] Extensions = { ".bmp", ".png", ".jpg", ".jpeg" };

        const string EmptyText = "";
        string rootFolder = FormPMS.EmptyText;

        double d_zoom;

        bool b_showLayer1;
        bool b_showLayer2;
        bool b_showLayer3;
        bool b_showText;

        bool b_layer2Changed;
        bool b_layer3Changed;
        bool b_textChanged;

        bool b_active;
        int PreIndexOfListbox;
        bool b_indexRestoring = false;

        Color penColor;
        Color transparent;
        Color drawColor;
        
        Bitmap pictureBox2bmp;
        Bitmap pictureBox3bmp;

        const int InitPensize = 3;
        int pensizeD = InitPensize;
        int pensizeE = InitPensize + 5;
        int pensize = InitPensize;

        LayerC layer1;
        LayerC layer2;
        LayerC layer3;
        Bitmap laster;

        Size InitialSize = new Size(100, 100);
        Color[] colorsWithoutAlpha;

        bool start_DRAW = false;  // true = 描画中
        Point startP_DRAW;     // 起点

        bool b_mode_lightMode;

        bool b_filecopying = false;

        Cursor n8c;
        Cursor n16c;
        Cursor n32c;

        /// <summary>
        /// 
        /// </summary>
        private bool B_L2C
        {
            set 
            { 
                this.b_layer2Changed = value;
                buttonSaveLayer2.Enabled = value;
            }
            get { return this.b_layer2Changed; }
        }

        private bool B_L3C
        {
            set 
            { 
                this.b_layer3Changed = value;
                buttonSaveLayer3.Enabled = value;
            }
            get { return this.b_layer3Changed; }
        }

        private bool B_TC
        {
            set 
            { 
                this.b_textChanged = value;
                buttonSaveText.Enabled = value;
            }
            get { return this.b_textChanged; }
        }

        private bool B_ACTIVE
        {
            set
            {
                this.b_active = value;
                if (!value)
                {
                    B_L2C = value;
                    B_L3C = value;
                    B_TC = value;
                }
                if (value)
                {
                    PreIndexOfListbox = listBox1.SelectedIndex;
                }
            }
            get
            {
                return this.b_active;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public FormPMS()
        {
            InitializeComponent();

            colorsWithoutAlpha = new Color[9];
            colorsWithoutAlpha[0] = Color.FromArgb(0, 255, 0, 0);
            colorsWithoutAlpha[1] = Color.FromArgb(0, 255, 255, 0);
            colorsWithoutAlpha[2] = Color.FromArgb(0, 0, 127, 0);
            colorsWithoutAlpha[3] = Color.FromArgb(0, 0, 255, 255);
            colorsWithoutAlpha[4] = Color.FromArgb(0, 0, 0, 255);
            colorsWithoutAlpha[5] = Color.FromArgb(0, 255, 0, 255);
            colorsWithoutAlpha[6] = Color.FromArgb(0, 255, 255, 255);
            colorsWithoutAlpha[7] = Color.FromArgb(0, 127, 127, 127);
            colorsWithoutAlpha[8] = Color.FromArgb(0, 5, 5, 5);

            pictureBox2bmp = new Bitmap(pictureBox2.Width, pictureBox2.Height);
            pictureBox3bmp = new Bitmap(pictureBox3.Width, pictureBox3.Height);

            laster = new Bitmap(this.InitialSize.Width, this.InitialSize.Height);

            
            checkBoxShowLayer1.Checked = true;
            checkBoxShowLayer2.Checked = true;
            checkBoxShowLayer3.Checked = true;
            checkBoxShowLayer1.Enabled = false; // 
            checkBoxShowText.Checked = true;
            radioButtonTargetLayer2.Checked = true;
            radioButtonDraw.Checked = true;

            this.MinimumSize = this.Size;
            this.labelRootFolder.Text = FormPMS.EmptyText;
            
            
            pictureBox2.Image = pictureBox2bmp;
            pictureBox3.Image = pictureBox3bmp;
            trackBarAlpha.Value = trackBarAlpha.Maximum;
            trackBarPensize.Value = InitPensize;
            int index = 4;
            setPictureBox3bmp(Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));

            pictureBox1.Size = this.InitialSize;
            pictureBox1.Image = laster;
            pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
            pictureBox1.BackgroundImageLayout = ImageLayout.Stretch;

            B_L2C = false;
            B_L3C = false;
            B_TC = false;
            
            this.FormPmsSub();

            layer1 = new LayerC(this.InitialSize, transparent);
            layer2 = new LayerC(this.InitialSize, transparent);
            layer3 = new LayerC(this.InitialSize, transparent);
            radioButtonZoom100.Checked = true;

            goToNormalModeToolStripMenuItem.Enabled = false;
            goToLightModeToolStripMenuItem.Enabled = true;
            goToLightModeToolStripMenuItem_Click(new object(), new EventArgs());
        }

        private void FormPmsSub()
        {
            Bitmap bmp = null;
                        
            try
            {
                panel1.BackgroundImage = Image.FromFile("panelbackgroundimage.png");
                bmp = new Bitmap("panelbackgroundimage.png");
                if (laster.Width > bmp.Width && laster.Height > bmp.Height)
                {
                    for (int x = 0; x < bmp.Width; x++)
                    {
                        for (int y = 0; y < bmp.Height; y++)
                        {
                            laster.SetPixel(x, y, bmp.GetPixel(x, y));
                        }
                    }
                }
            }
            catch(Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            finally
            {
                if (bmp != null)
                    bmp.Dispose();
            }

            bmp = null;
            try
            {
                bmp = new Bitmap("panelbackgroundcolor.png");
                panel1.BackColor = bmp.GetPixel(0,0);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            finally
            {
                if (bmp != null)
                    bmp.Dispose();
            }

            bmp = null;
            try
            {
                bmp = new Bitmap("pictureboxbackgroundcolor.png");
                pictureBox1.BackColor = bmp.GetPixel(0, 0);
                pictureBox2.BackColor = bmp.GetPixel(0, 0);
                pictureBox3.BackColor = bmp.GetPixel(0, 0);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            finally
            {
                if (bmp != null)
                    bmp.Dispose();
            }

            bmp = null;
            try
            {
                bmp = new Bitmap("colortransparent.png");
                this.transparent = bmp.GetPixel(0, 0);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
                this.Dispose();
            }
            finally
            {
                if (bmp != null)
                    bmp.Dispose();
            }

            try
            {
                historyLoadAndSet();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }

            try
            {
                n8c = new Cursor("n8.cur");
            }
            catch (Exception e)
            {
                n8c = Cursors.Arrow;
            }

            try
            {
                n16c = new Cursor("n16.cur");
            }
            catch (Exception e)
            {
                n16c = Cursors.Arrow;
            }

            try
            {
                n32c = new Cursor("n32.cur");
            }
            catch (Exception e)
            {
                n32c = Cursors.Arrow;
            }

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void openFolderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (checkBoxNotifySave.Checked)
            {
                if (notifySaveAnd("continue?") == DialogResult.No)
                {
                    return;
                }
            }


            FolderBrowserDialog fbd = new FolderBrowserDialog();
            fbd.Description = "select folder";
            fbd.RootFolder = Environment.SpecialFolder.Desktop;
            fbd.ShowNewFolderButton = false;

            if (fbd.ShowDialog(this) == DialogResult.OK)
            {
                rootFolder = fbd.SelectedPath;
                labelRootFolder.Text = rootFolder;
                prepare();
                historyAdd(rootFolder);
                historyLoadAndSet();
            }
        }

        private void prepare()
        {
            B_ACTIVE = false;
            B_L2C = false;
            B_L3C = false;
            B_TC = false;

            if (rootFolder == FormPMS.EmptyText || !Directory.Exists(rootFolder))
            {
                return;
            }

            try
            {
                checkSubFolder();
                checkOrderfile();
                comparePicturesAndOrderfile();
                listboxRefresh();
                fontSettingsLoadFromFile();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
        }

        private void checkSubFolder()
        {
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            if(!Directory.Exists(subFolder))
            {
                MessageBox.Show(string.Format("create folder : {0}", subFolder), "create");
                Directory.CreateDirectory(subFolder);
            }
        }

        private void checkOrderfile()
        {
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string orderFile = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.OrderTextFileName;
            if (!File.Exists(orderFile))
            {
                
                MessageBox.Show(string.Format("create orderfile : {0}", orderFile), "create");
                File.Create(orderFile).Close();
                DialogResult result = MessageBox.Show(
                    "yes : lastWriteTime" + Environment.NewLine + "no : fileName",
                    "orderfile order",
                    MessageBoxButtons.YesNo);
                List<string> pictures = getPicturesFullpath(rootFolder);
                if (result == DialogResult.Yes)
                {
                    // lastWriteTime
                    Dictionary<string, DateTime> dict = new Dictionary<string, DateTime>();
                    foreach (string s in pictures)
                    {
                        dict.Add(s, File.GetLastWriteTime(s));
                    }
                    var orderd = dict.OrderBy((d) => d.Value);
                    string str = FormPMS.EmptyText;
                    foreach(var kbp in orderd)
                    {
                        string fileName = Path.GetFileName(kbp.Key);
                        str += fileName;
                        str += Environment.NewLine;
                    }
                    using (StreamWriter sw = new StreamWriter(orderFile, false, USE_ENCODING))
                    {
                        sw.Write(str);
                    }
                    
                }
                else
                {
                    // fileName
                    pictures.Sort();
                    string str = FormPMS.EmptyText;
                    foreach (string s in pictures)
                    {
                        string fileName = Path.GetFileName(s);
                        str += fileName;
                        str += Environment.NewLine;
                    }
                    using (StreamWriter sw = new StreamWriter(orderFile, false, USE_ENCODING))
                    {
                        sw.Write(str);
                    }
                }
            }
        }

        private List<string> getPicturesFullpath(string folderPath)
        {
            List<string> pictures = new List<string>();
            string[] files = Directory.GetFiles(folderPath);
            foreach (string file in files)
            {
                string ext = Path.GetExtension(file);
                for (int i = 0; i < Extensions.Length; i++)
                {
                    if (ext == Extensions[i])
                    {
                        pictures.Add(file);
                    }
                }
            }
            return pictures;
        }

        private void comparePicturesAndOrderfile()
        {     
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string orderFile = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.OrderTextFileName;
            
            List<string> pictures = getPicturesFullpath(rootFolder);
            RichTextBox rtb = new RichTextBox();
            using (StreamReader sr = new StreamReader(orderFile, USE_ENCODING))
            {
                rtb.Text = sr.ReadToEnd();
            }
            string[] lines = rtb.Lines;
            string newPictures = FormPMS.EmptyText;
            foreach (string picture in pictures)
            {
                string filename = Path.GetFileName(picture);
                bool find = false;
                for(int i = 0; i < lines.Length; i++)
                {
                    if( filename == lines[i])
                    {
                        find = true;
                        continue;
                    }
                }
                if(!find)
                {
                    newPictures += filename;
                    newPictures += Environment.NewLine;
                }
            }
            if (newPictures != FormPMS.EmptyText)
            {
                MessageBox.Show(newPictures, "add to orderfile");
                File.Copy(orderFile, orderFile + ".bak", true);
                if (rtb.Lines.Length != 0 && rtb.Lines[rtb.Lines.Length - 1] != FormPMS.EmptyText)
                {
                    rtb.Text += Environment.NewLine;
                }
                rtb.Text += newPictures;
                using (StreamWriter sw = new StreamWriter(orderFile, false, USE_ENCODING))
                {
                    sw.Write(rtb.Text);
                }
            }
        }

        void listboxRefresh()
        {

            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string orderFile = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.OrderTextFileName;
       
            listBox1.Items.Clear();
            RichTextBox rtb = new RichTextBox();
            using (StreamReader sr = new StreamReader(orderFile, USE_ENCODING))
            {
                rtb.Text = sr.ReadToEnd();
            }
            string[] lines = rtb.Lines;
            foreach (string filename in lines)
            {
                string fileFullpath = rootFolder + Path.DirectorySeparatorChar.ToString() + filename;
                if(File.Exists(fileFullpath))
                {
                    listBox1.Items.Add(filename);
                }
            }
            listBox1.SelectedIndex = -1;
        }

        private void fontSettingsLoadFromFile()
        {
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;

            string fontSettingTextbox = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.FontSettingTextboxFileName;
            string fontSettingListbox = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.FontSettingListboxFileName;

            if (File.Exists(fontSettingTextbox))
            {
                loadFontSetting(textBox1, fontSettingTextbox);
            }
            else
            {
                // 強制的に作る。
                saveFontSetting(textBox1.Font, fontSettingTextbox);
            }

            if (File.Exists(fontSettingListbox))
            {
                loadFontSetting(listBox1, fontSettingListbox);
            }
            else
            {
                // 強制的に作る。
                saveFontSetting(listBox1.Font, fontSettingListbox);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 
        private void radioButtonZoom50_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonZoom50.Checked)
            {
                d_zoom = 0.50;
                radioButtonzoomCheckedChanged();
            }
        }

        private void radioButtonZoom75_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonZoom75.Checked)
            {
                d_zoom = 0.75;
                radioButtonzoomCheckedChanged();
            }
        }

        private void radioButtonZoom100_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonZoom100.Checked)
            {
                d_zoom = 1.0;
                radioButtonzoomCheckedChanged();
            }
        }

        private void radioButtonZoom150_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonZoom150.Checked)
            {
                d_zoom = 1.50;
                radioButtonzoomCheckedChanged();
            }
        }

        private void radioButtonZoom200_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonZoom200.Checked)
            {
                d_zoom = 2.0;
                radioButtonzoomCheckedChanged();
            }
        }

        private void radioButtonzoomCheckedChanged()
        {
            trackBarZoom.Value = (int)(d_zoom * 100);
            zoomApplyPictureboxSize();
        }

        private void zoomApplyPictureboxSize()
        {
            labelZoom.Text = trackBarZoom.Value.ToString();
            double d_width = this.laster.Width * d_zoom;
            double d_height = this.laster.Height * d_zoom;
            int width = (int)Math.Ceiling(d_width);
            int height = (int)Math.Ceiling(d_height);
            pictureBox1.Size = new Size(width, height);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 
        private void checkBoxShowLayer1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxShowLayer1.Checked)
                b_showLayer1 = true;
            else
                b_showLayer1 = false;
        }

        private void checkBoxShowLayer2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxShowLayer2.Checked)
                b_showLayer2 = true;
            else
                b_showLayer2 = false;

            if (B_ACTIVE)
            {
                // 元のカーソルを保持
                Cursor preCursor = Cursor.Current;
                // カーソルを待機カーソルに変更
                Cursor.Current = Cursors.WaitCursor;

                Rectangle rect = new Rectangle(0, 0, laster.Width, laster.Height);
                mergeLayersAndSetPictureBox1Image(rect);

                // カーソルを元に戻す
                Cursor.Current = preCursor;
            }
        }

        private void checkBoxShowLayer3_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxShowLayer3.Checked)
                b_showLayer3 = true;
            else
                b_showLayer3 = false;

            if (B_ACTIVE)
            {
                // 元のカーソルを保持
                Cursor preCursor = Cursor.Current;
                // カーソルを待機カーソルに変更
                Cursor.Current = Cursors.WaitCursor;

                Rectangle rect = new Rectangle(0, 0, laster.Width, laster.Height);
                mergeLayersAndSetPictureBox1Image(rect);

                // カーソルを元に戻す
                Cursor.Current = preCursor;
            }
        }

        private void checkBoxShowText_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxShowText.Checked)
            {
                b_showText = true;
                textBox1.Visible = true;
            }
            else
            {
                b_showText = false;
                textBox1.Visible = false;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void FormPMS_Resize(object sender, EventArgs e)
        {
            //panel1.Width = this.Width - panel1.Location.X - 15;
            //panel1.Height = this.Height - panel1.Location.Y - 37;
            panel1.Width = this.ClientSize.Width - panel1.Left;
            panel1.Height = this.ClientSize.Height - panel1.Top;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void trackBarAlpha_ValueChanged(object sender, EventArgs e)
        {
            labelAlpha.Text = trackBarAlpha.Value.ToString();
            int step = pictureBox2bmp.Width / 9;
            for (int x = 0; x < pictureBox2bmp.Width; x++)
            {
                for (int y = 0; y < pictureBox2bmp.Height; y++)
                {
                    int index = x / step;
                    switch(index)
                    {
                        case 0:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 1:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 2:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 3:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 4:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 5:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 6:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 7:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        case 8:
                            pictureBox2bmp.SetPixel(x, y, Color.FromArgb(trackBarAlpha.Value, colorsWithoutAlpha[index].R, colorsWithoutAlpha[index].G, colorsWithoutAlpha[index].B));
                            break;
                        default:
                            break;

                    }
                }
            }
            pictureBox2.Invalidate();

        }

        private void pictureBox2_MouseUp(object sender, MouseEventArgs e)
        {
            try
            {
                Color c = pictureBox2bmp.GetPixel(e.X, e.Y);

                // 追加。
                radioButtonDraw.Checked = true;

                if (radioButtonDraw.Checked)
                {
                    drawColor = c;
                    setPictureBox3bmp(c);
                }
            }
            catch (Exception exc)
            {
            }
        }

        private void setPictureBox3bmp(Color c)
        {
            for (int x = 0; x < pictureBox3bmp.Width; x++)
            {
                for (int y = 0; y < pictureBox3bmp.Height; y++)
                {
                    pictureBox3bmp.SetPixel(x, y, c);
                }
            }
            penColor = c;
            pictureBox3.Invalidate();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void trackBarPensize_ValueChanged(object sender, EventArgs e)
        {
            this.labelPensize.Text = trackBarPensize.Value.ToString();
            this.pensize = trackBarPensize.Value;
            if (radioButtonDraw.Checked)
            {
                pensizeD = pensize;
            }
            else if (radioButtonErase.Checked)
            {
                pensizeE = pensize;
            }
        }

        private void radioButtonDraw_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonDraw.Checked)
            {
                pensize = pensizeD;
                trackBarPensize.Value = pensize;
                setPictureBox3bmp(drawColor);
                
            }
        }

        private void radioButtonErase_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonErase.Checked)
            {
                pensize = pensizeE;
                trackBarPensize.Value = pensize;
                setPictureBox3bmp(transparent);
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (b_filecopying || b_indexRestoring)
                return;

            if (checkBoxNotifySave.Checked)
            {
                if (notifySaveAnd("continue?") == DialogResult.No)
                {
                    b_indexRestoring = true;
                    listBox1.SelectedIndex = PreIndexOfListbox;
                    b_indexRestoring = false;
                    return;
                }
            }

            B_ACTIVE = false;

            if (listBox1.SelectedIndex == -1)
                return;            

            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string orderFile = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.OrderTextFileName;

            string filename = listBox1.SelectedItem.ToString();

            if (!File.Exists(rootFolder + Path.DirectorySeparatorChar.ToString() + filename))
            {
                MessageBox.Show("file not exist");
                return;
            }


            // 元のカーソルを保持
            Cursor preCursor = Cursor.Current;
            // カーソルを待機カーソルに変更
            Cursor.Current = Cursors.WaitCursor;

            Bitmap bmp = new Bitmap(rootFolder + Path.DirectorySeparatorChar.ToString() + filename);
            int bmpWidth = bmp.Width;
            int bmpHeight = bmp.Height;
            if (b_mode_lightMode)
            {
                pictureBox1.BackgroundImage = new Bitmap(bmp);
            }
            else
            {
                layer1 = new LayerC(bmp, this.transparent);
            }
            bmp.Dispose();

            if (File.Exists(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer2Ex))
            {
                Bitmap bmp2 = new Bitmap(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer2Ex);
                if (bmp2.Width != bmpWidth || bmp2.Height != bmpHeight)
                {
                    MessageBox.Show("bmp2 size error");
                    layer2 = new LayerC(new Size(bmpWidth, bmpHeight), this.transparent);
                }
                layer2 = new LayerC(bmp2, this.transparent);
                bmp2.Dispose();
            }
            else
            {
                layer2 = new LayerC(new Size(bmpWidth, bmpHeight), this.transparent);
            }

            if (File.Exists(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer3Ex))
            {
                Bitmap bmp3 = new Bitmap(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer3Ex);
                if (bmp3.Width != bmpWidth || bmp3.Height != bmpHeight)
                {
                    MessageBox.Show("bmp3 size error");
                    layer3 = new LayerC(new Size(bmpWidth, bmpHeight), this.transparent);
                }
                layer3 = new LayerC(bmp3, this.transparent);
                bmp3.Dispose();
            }
            else
            {
                layer3 = new LayerC(new Size(bmpWidth, bmpHeight), this.transparent);
            }

            if (File.Exists(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.MemoTextEx))
            {
                using(StreamReader sr = new StreamReader(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.MemoTextEx))
                {
                    textBox1.Text = sr.ReadToEnd();
                }
            }
            else
            {
                textBox1.Text = FormPMS.EmptyText;
            }

            laster = new Bitmap(bmpWidth, bmpHeight);
            //

            pictureBox1.Image = laster;
            radioButtonzoomCheckedChanged();
            Rectangle rect = new Rectangle(0, 0, laster.Width, laster.Height);
            mergeLayersAndSetPictureBox1Image(rect);
            
            B_ACTIVE = true;

            // カーソルを元に戻す
            Cursor.Current = preCursor;
       
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            TextboxTextChangedEventDelegate ttced = TextboxTextChangedEvent;

            if (ttced != null)
            {
                ttced(textBox1.Text, textBox1.SelectionStart);
            }


            if (B_ACTIVE)
                B_TC = true;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (!B_ACTIVE)
                return;

            if (B_ACTIVE)
            {
                if (radioButtonTargetLayer2.Checked)
                    B_L2C = true;
                else if (radioButtonTargetLayer3.Checked)
                    B_L3C = true;
            }

            Point p = pictureBoxPointToLayerPoint(e);
            start_DRAW = true;
            startP_DRAW = p;
            return;

        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (!B_ACTIVE)
                return;

            if (start_DRAW == false) return;

            LayerC targetLayer = layer2;
            if (radioButtonTargetLayer2.Checked)
            {
                targetLayer = layer2;
            }
            else if (radioButtonTargetLayer3.Checked)
            {
                targetLayer = layer3;
            }
            Point p = pictureBoxPointToLayerPoint(e);
            Rectangle rect = targetLayer.DrawLine(penColor, startP_DRAW, p, pensize, false, LayerC.DrawLinePenKind.CIRCLE_FILL, checkBoxAntiAliasing.Checked);
            mergeLayersAndSetPictureBox1Image(rect);
            startP_DRAW = p;
            return;
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            if (!B_ACTIVE)
                return;

            // Point p = pictureBoxPointToLayerPoint(e);
            start_DRAW = false;
            return;
        }

        private Point pictureBoxPointToLayerPoint(MouseEventArgs e)
        {
            Point p = new Point(e.X, e.Y);
            p.X = (int)Math.Floor(p.X / d_zoom);
            p.Y = (int)Math.Floor(p.Y / d_zoom);
            return p;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSaveText_Click(object sender, EventArgs e)
        {
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string filename = listBox1.SelectedItem.ToString();
            using (StreamWriter sw = new StreamWriter(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.MemoTextEx, false, USE_ENCODING))
            {
                sw.Write(textBox1.Text);
            }
            B_TC = false;
        }

        private void buttonSaveLayer2_Click(object sender, EventArgs e)
        {
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string filename = listBox1.SelectedItem.ToString();
            try
            {
                // System.Drawing.Imaging.ImageFormat.Bmp だとアルファ値が強制255される
                layer2.getBitmap().Save(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer2Ex,
                    System.Drawing.Imaging.ImageFormat.MemoryBmp);
            }
            catch(Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
            B_L2C = false;
        }

        private void buttonSaveLayer3_Click(object sender, EventArgs e)
        {
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string filename = listBox1.SelectedItem.ToString();
            try
            {
                // System.Drawing.Imaging.ImageFormat.Bmp だとアルファ値が強制255される
                layer3.getBitmap().Save(subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer3Ex,
                    System.Drawing.Imaging.ImageFormat.MemoryBmp);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
            B_L3C = false;
        }

        // layerで考えて描き換えたい範囲を引数にする
        private void mergeLayersAndSetPictureBox1Image(Rectangle rect)
        {
            mergeLayers(rect);
            setPictureBox1Image(rect);
        }

        // layerで考えて描き換えたい範囲を引数にする
        private void mergeLayers(Rectangle rect)
        {
            int sx = rect.Left;
            int sy = rect.Top;
            int ex = rect.Left + rect.Width;
            int ey = rect.Top + rect.Height;
            if (sx < 0) sx = 0;
            if (sy < 0) sy = 0;
            if (ex > laster.Width) ex = laster.Width;
            if (ey > laster.Height) ey = laster.Height;

            // lasterの描き変え範囲を用意する。
            LayerC[] layers = { layer1, layer2, layer3 };
            for (int x = sx; x < ex; x++)
            {
                for (int y = sy; y < ey; y++)
                {
                    Color c = getMixedArgbFromLayerDots(layers, x, y);
                    laster.SetPixel(x, y, c);
                }
            }
        }

        // layerで考えて描き換えたい範囲を引数にする
        private void setPictureBox1Image(Rectangle rect)
        {
            Rectangle realRect = layerRectToRealRect(rect);
            pictureBox1.Invalidate(realRect);
            pictureBox1.Update();
            //String str = String.Format("{0}, {1}, {2}, {3}", realRect.X, realRect.Y, realRect.Width, realRect.Height);
            //Debug.WriteLine(str);
        }

        private Rectangle layerRectToRealRect(Rectangle rect)
        {
            Rectangle r = new Rectangle();
            r.X = (int)Math.Floor(rect.X * d_zoom);
            r.Y = (int)Math.Floor(rect.Y * d_zoom);
            r.Width = (int)Math.Ceiling(rect.Width * d_zoom);
            r.Height = (int)Math.Ceiling(rect.Height * d_zoom);

            {
                int temp = 10;
                r.X = r.X - temp;
                r.Y = r.Y - temp;
                r.Width = r.Width + temp * 3;
                r.Height = r.Height + temp * 3;
            }


            return r;
        }

        // ///////////////////////////////////////////////////////////////////////

        private Color getMixedArgbFromLayerDots(LayerC[] layers, int x, int y)
        {
            Color c;

            if (b_mode_lightMode)
            {
                c = layers[1].getDot(x, y);

                if (checkBoxShowLayer3.Checked)
                    c = getMixedArgbFrom2Argb(c, layers[2].getDot(x, y));
            }
            else
            {
                c = layers[0].getDot(x, y);

                if (checkBoxShowLayer2.Checked)
                    c = getMixedArgbFrom2Argb(c, layers[1].getDot(x, y));

                if (checkBoxShowLayer3.Checked)
                    c = getMixedArgbFrom2Argb(c, layers[2].getDot(x, y));
            }
            
            return c;
        }

        // c2がレイヤー番号大きい方
        private Color getMixedArgbFrom2Argb(Color c1, Color c2)
        {
            Color  resultC;
            int[] argb1colors = { c1.R, c1.G, c1.B };
            int[] argb2colors = { c2.R, c2.G, c2.B };
            if (IsColorsTransparent(c1))
            {
                // 片方が透明色ならもう一方を
                resultC = c2;
            }
            else if (IsColorsTransparent(c2))
            {
                // 片方が透明色ならもう一方を
                resultC = c1;
            }
            else
            {
                // 両方とも透明色ではない。

                    // alpha
                    int alpha = Math.Max(c1.A, c2.A);
                    // rgb
                    double[] cmyk1 = RGBtoCMYK(c1.R, c1.G, c1.B);
                    double[] cmyk2 = RGBtoCMYK(c2.R, c2.G, c2.B);
                    double[] mixedcmyk = MixCMYKwithAlpha(c1.A, cmyk1, c2.A, cmyk2);
                    int[] tmpcolors = CMYKtoRGB(mixedcmyk);
                    int red = tmpcolors[0];
                    int green = tmpcolors[1];
                    int blue = tmpcolors[2];
                    resultC = Color.FromArgb(alpha, red, green, blue);
            }
            return resultC;
        }

        private bool IsColorsTransparent(Color c)
        {
            bool result = false;
            if (transparent == c)
            {
                result = true;
            }
            return result;
        }

        private double[] RGBtoCMYK(int red, int green, int blue)
        {
            double dred = red;
            double dgreen = green;
            double dblue = blue;
            double[] cmyk = new double[4];
            double black = Math.Min(1 - dred / 255, Math.Min(1 - dgreen / 255, 1 - dblue / 255));
            cmyk[0] = (1 - (dred / 255) - black) / (1 - black);
            cmyk[1] = (1 - (dgreen / 255) - black) / (1 - black);
            cmyk[2] = (1 - (dblue / 255) - black) / (1 - black);
            cmyk[3] = black;

            //if (transparent == red && transparent == green && transparent == white)
            //{
            //    cmyk[0] = transparent2;
            //    cmyk[1] = transparent2;
            //    cmyk[2] = transparent2;
            //    cmyk[3] = transparent2;
            //}
            return cmyk;
        }

        // alpha1はとりあえず使わない。
        private double[] MixCMYKwithAlpha(int alpha1, double[] cmyk1, int alpha2, double[] cmyk2)
        {
            double[] cmyk = new double[4];

            for (int i = 0; i < 4; i++)
            {
                int alpha_max = 255;
                cmyk[i] = cmyk1[i] * (alpha_max - alpha2) / alpha_max +
                    cmyk2[i] * alpha2 / alpha_max;
                if (cmyk[i] > 1) cmyk[i] = 1.0;
                if (cmyk[i] < 0) cmyk[i] = 0.0;
            }

            if (alpha2 == 255)
            {
                cmyk[0] = cmyk2[0];
                cmyk[1] = cmyk2[1];
                cmyk[2] = cmyk2[2];
                cmyk[3] = cmyk2[3];
            }
            return cmyk;
        }

        private double[] MixCMYK(double[] cmyk1, double[] cmyk2)
        {
            double[] cmyk = new double[4];

            //if (IsTransparent2(cmyk1)){
            //    cmyk[0]= cmyk2[0];
            //    cmyk[1]= cmyk2[1];
            //    cmyk[2]= cmyk2[2];
            //    cmyk[3]= cmyk2[3];
            //}
            //else if (IsTransparent2(cmyk2))
            //{
            //    cmyk[0] = cmyk1[0];
            //    cmyk[1] = cmyk1[1];
            //    cmyk[2] = cmyk1[2];
            //    cmyk[3] = cmyk1[3];
            //}
            //else
            //{
            for (int i = 0; i < 4; i++)
            {
                double large = Math.Max(cmyk1[i], cmyk2[i]);
                double small = Math.Min(cmyk1[i], cmyk2[i]);

                //cmyk[i] = small + (large - small) * (1.0 - (large - small));
                //cmyk[i] = large + (large - small) * (1.0 - (large - small));

                cmyk[i] = (cmyk1[i] + cmyk2[i]) / 2;
                if (cmyk[i] > 1) cmyk[i] = 1.0;
                if (cmyk[i] < 0) cmyk[i] = 0.0;
            }
            //}  
            return cmyk;
        }

        private int[] CMYKtoRGB(double[] cmyk)
        {
            int[] colors = new int[3];
            //if (IsTransparent2(cmyk))
            //{
            //    colors[0] = colors[1] = colors[2] = transparent;
            //    return colors;
            //}
            //else
            //{
            double cyan = cmyk[0];
            double magenta = cmyk[1];
            double yellow = cmyk[2];
            double black = cmyk[3];
            int red = (int)((1 - Math.Min(1, cyan * (1 - black) + black)) * 255);
            int green = (int)((1 - Math.Min(1, magenta * (1 - black) + black)) * 255);
            int blue = (int)((1 - Math.Min(1, yellow * (1 - black) + black)) * 255);
            if (red < 0) red = 0;
            if (green < 0) green = 0;
            if (blue < 0) blue = 0;
            if (red > 255) red = 255;
            if (green > 255) green = 255;
            if (blue > 255) blue = 255;
            colors[0] = red; colors[1] = green; colors[2] = blue;
            return colors;
            //}
        }

        private void saveLasterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();

            sfd.Filter = "ファイル(*.png)|*.png";
            sfd.Title = "保存先のファイルを選択してください";

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                Bitmap bmp = new Bitmap(laster);

                bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.MemoryBmp);
                bmp.Dispose();
            }
        }

        private void goToLightModeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            checkBoxShowLayer2.Checked = true;
            checkBoxShowLayer2.Enabled = false;

            //radioButtonZoom100.Checked = true;
            //groupBoxZoom.Enabled = false;

            b_mode_lightMode = true;

            goToLightModeToolStripMenuItem.Enabled = false;
            goToNormalModeToolStripMenuItem.Enabled = true;

            modeChanged();
        }

        private void goToNormalModeToolStripMenuItem_Click(object sender, EventArgs e)
        {

            checkBoxShowLayer2.Enabled = true;

            //groupBoxZoom.Enabled = true;

            b_mode_lightMode = false;

            goToNormalModeToolStripMenuItem.Enabled = false;
            goToLightModeToolStripMenuItem.Enabled = true;

            modeChanged();
        }

        private void modeChanged()
        {
            if (!B_ACTIVE)
                return;


            // 元のカーソルを保持
            Cursor preCursor = Cursor.Current;
            // カーソルを待機カーソルに変更
            Cursor.Current = Cursors.WaitCursor;

            layer1 = null;
            pictureBox1.BackgroundImage = null;

            string filename = listBox1.SelectedItem.ToString();
            Bitmap bmp = new Bitmap(rootFolder + Path.DirectorySeparatorChar.ToString() + filename);
            int bmpWidth = bmp.Width;
            int bmpHeight = bmp.Height;
            if (b_mode_lightMode)
            {
                pictureBox1.BackgroundImage = new Bitmap(bmp);
            }
            else
            {
                layer1 = new LayerC(bmp, this.transparent);
            }
            bmp.Dispose();

            Rectangle rect = new Rectangle(0, 0, laster.Width, laster.Height);
            mergeLayersAndSetPictureBox1Image(rect);

            // カーソルを元に戻す
            Cursor.Current = preCursor;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void getThumbnailsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!B_ACTIVE)
            {
                MessageBox.Show("not active", "error");
                return;
            }

            int step = 3;

            if (b_mode_lightMode)
            {
                layer1 = new LayerC((Bitmap)pictureBox1.BackgroundImage, transparent);
            }


            int width = laster.Width / step * 3;
            int height = laster.Height / step * 3;

            Form thumForm = new Form();
            PictureBox thumPic = new PictureBox();
            thumPic.Name = "thumPic";
            thumPic.BackColor = pictureBox1.BackColor;
            thumForm.Text = "this picturebox's backcolor = " + thumPic.BackColor.ToString();
            Bitmap thumBit = new Bitmap(width, height); //, FORMAT);
            Button getButton = new Button();
            Label label_step = new Label();
            label_step.Text = step.ToString();
            label_step.Name = "label_step";

            thumForm.Controls.Add(thumPic);
            thumForm.Controls.Add(getButton);
            thumForm.Controls.Add(label_step);


            thumPic.Image = thumBit;
            thumPic.Size = new Size(width, height);
            thumForm.Size = new Size(width + 50, height + 100);

            getButton.Location = new System.Drawing.Point(20, 20 + height);
            getButton.Text = "get";
            getButton.Click += new EventHandler(thumForm_getButton_Click);

            setThumnails(thumBit, step);

            //
            getButton.Enabled = false;

            thumForm.Show();
            thumPic.Invalidate();
            thumPic.Update();
        }

        void thumForm_getButton_Click(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            Form thumForm = (Form)(((Button)sender).Parent);
            Control[] controls = thumForm.Controls.Find("thumPic", true);
            PictureBox pictureBox = (PictureBox)controls[0];
            Control[] controls2 = thumForm.Controls.Find("label_step", true);
            Label label = (Label)controls2[0];
            int step = int.Parse(label.Text);

            setThumnails((Bitmap)pictureBox.Image, step);
            pictureBox.Invalidate();
            pictureBox.Update();
        }

        private void setThumnails(Bitmap thumBit, int step)
        {
            Color black = Color.FromArgb(255, 0, 0, 0);
            Color white = Color.FromArgb(255, 255, 255, 255);

            int startx;
            int wx = laster.Width / step;
            int starty;
            int hy = laster.Height / step;

            startx = 0;
            starty = 0;
            int layerx = 0;
            int layery = 0;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer1, thumBit, black, 0);
            startx = wx; starty = 0;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer1, thumBit, white, 1);
            startx = wx * 2; starty = 0;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer1, thumBit, white, -1);

            startx = 0; starty = hy;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer2, thumBit, black, 0);
            startx = wx; starty = hy;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer2, thumBit, white, 1);
            startx = wx * 2; starty = hy;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer2, thumBit, white, -1);

            startx = 0; starty = hy * 2;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer3, thumBit, black, 0);
            startx = wx; starty = hy * 2;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer3, thumBit, white, 1);
            startx = wx * 2; starty = hy * 2;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer3, thumBit, white, -1);

            //startx = 0; starty = hy * 3;
            //setthumBit(startx, starty, wx, hy, layerx, layery, step, layer4, thumBit, black, 0);
            //startx = wx; starty = hy * 3;
            //setthumBit(startx, starty, wx, hy, layerx, layery, step, layer4, thumBit, white, 1);
            //startx = wx * 2; starty = hy * 3;
            //setthumBit(startx, starty, wx, hy, layerx, layery, step, layer4, thumBit, white, -1);

        }

        // modeは0または1またはそれ以外
        private void setthumBit(int startx, int starty, int wx, int hy, int layerx, int layery, int step, LayerC layer, Bitmap thumBit, Color color, int mode)
        {
            // mode1で仕用
            Color blue = Color.FromArgb(255, 0, 0, 255);
            Color white = Color.FromArgb(255, 255, 255, 255);

            int lx = layerx;


            for (int x = startx; x < startx + wx; x++)
            {
                int ly = layery;
                for (int y = starty; y < starty + hy; y++)
                {

                    if (layer.getDot(lx, ly) == transparent)　// 透過色の部分
                    {

                        if (mode == 0)　// 透過色の部分は渡された色（color）で
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, color);
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else if (mode == 1) // 透過色の部分は青で
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, blue);
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else // layerのデータをコピー
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, Color.FromArgb(layer.getDot(lx, ly).A,
                                    layer.getDot(lx, ly).R,
                                    layer.getDot(lx, ly).G,
                                    layer.getDot(lx, ly).B
                                    ));
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                    }
                    else // 透過色じゃない部分
                    {
                        if (mode == 0) // layerのデータをコピー
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, Color.FromArgb(layer.getDot(lx, ly).A,
                                    layer.getDot(lx, ly).R,
                                    layer.getDot(lx, ly).G,
                                    layer.getDot(lx, ly).B
                                    ));
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else if (mode == 1) // 透過色じゃない部分は白で
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, white);
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else // layerのデータをコピー
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, Color.FromArgb(layer.getDot(lx, ly).A,
                                    layer.getDot(lx, ly).R,
                                    layer.getDot(lx, ly).G,
                                    layer.getDot(lx, ly).B
                                    ));
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                    }
                    ly += step;
                }
                lx += step;
            }
        LOOPEND: ;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void captureAndPasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormCaptureAndPaste fcap = new FormCaptureAndPaste();
            fcap.PasteImageEvent += new PasteImageEventDelegate(fcap_PasteImageEvent);
            fcap.Show();
        }

        void fcap_PasteImageEvent(Bitmap bmp, bool b_ignore, Color ignoreColor, Point pointToScreen, double opacity)
        {
            if (!B_ACTIVE)
                return;

            Point p = pictureBox1.PointToScreen(new Point(0, 0));
            int startx = pointToScreen.X - p.X;
            int starty = pointToScreen.Y - p.Y;

            LayerC to = layer2;

            if (radioButtonTargetLayer2.Checked)
            {
                to = layer2;
                //buttonSaveLayer2.Enabled = true;
                B_L2C = true;
            }
            else if (radioButtonTargetLayer3.Checked)
            {
                to = layer3;
                //buttonSaveLayer3.Enabled = true;
                B_L3C = true;
            }

            // 元のカーソルを保持
            Cursor preCursor = Cursor.Current;
            // カーソルを待機カーソルに変更
            Cursor.Current = Cursors.WaitCursor;

            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    Color c = bmp.GetPixel(x, y);
                    if (b_ignore && ignoreColor == c)
                    {
                        // 何もしない。
                        ;
                    }
                    else
                    {
                        Color c2 = Color.FromArgb((int)Math.Floor(c.A * opacity), c.R, c.G, c.B);
                        to.SetDot(startx + x, starty + y, c2);
                    }
                }
            }

            Rectangle rect = new Rectangle(startx, starty, bmp.Width, bmp.Height);
            mergeLayersAndSetPictureBox1Image(rect);

            // カーソルを元に戻す
            Cursor.Current = preCursor;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBoxFontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (rootFolder == FormPMS.EmptyText)
            {
                fontError();
                return;
            }

            FontDialog fd = new FontDialog();
            fd.Font = textBox1.Font;
            if (fd.ShowDialog() == DialogResult.OK)
            {
                textBox1.Font = fd.Font;
                string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
                string fontSettingTextbox = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.FontSettingTextboxFileName;
                saveFontSetting(textBox1.Font, fontSettingTextbox);
            }
        }

        private void listBoxFontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (rootFolder == FormPMS.EmptyText)
            {
                fontError();
                return;
            }

            FontDialog fd = new FontDialog();
            fd.Font = listBox1.Font;
            if (fd.ShowDialog() == DialogResult.OK)
            {
                listBox1.Font = fd.Font;
                string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
                string fontSettingListbox = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.FontSettingListboxFileName;
                saveFontSetting(listBox1.Font, fontSettingListbox);
            }
        }

        private void fontError()
        {
            MessageBox.Show("select folder before change font", "error");
        }

        private void saveFontSetting(Font f, string fileFullPath)
        {
            FontConverter cvt = new FontConverter();
            string s = cvt.ConvertToString(f);
            using (StreamWriter sw = new StreamWriter(fileFullPath, false, USE_ENCODING))
            {
                sw.Write(s);
            }
        }

        private void loadFontSetting(Control c, string fileFullPath)
        {
            string s = "";
            FontConverter cvt = new FontConverter();
            using (StreamReader sr = new StreamReader(fileFullPath, USE_ENCODING))
            {
                s = sr.ReadToEnd();
            }

            try
            {
                Font f = (Font)cvt.ConvertFromString(s);
                c.Font = f;
            }
            catch (Exception e)
            {
                throw e;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        ///
        private void historyLoadAndSet()
        {
            string exePath = Application.StartupPath;
            string historyFileName = exePath + Path.DirectorySeparatorChar.ToString() + FormPMS.HistoryFileName;

            historyToolStripMenuItem.DropDownItems.Clear();
            if(!File.Exists(historyFileName))
            {
                return;
            }

            RichTextBox rtb = new RichTextBox();
            using (StreamReader sr = new StreamReader(historyFileName, USE_ENCODING))
            {
                rtb.Text = sr.ReadToEnd();
            }
            string[] lines = rtb.Lines;
            List<string> paths = new List<string>();
            foreach (string s in lines)
            {
                if(Directory.Exists(s))
                {
                    paths.Add(s);
                }
            }

            if (paths.Count == 0)
            {
                return;
            }

            string[] paths2 = paths.ToArray();
            ToolStripMenuItem[] tsmis = new ToolStripMenuItem[paths2.Length];
            for (int i = 0; i < paths2.Length; i++)
            {
                tsmis[i] = new ToolStripMenuItem();
                tsmis[i].Text = paths2[i];
                tsmis[i].Click += new EventHandler(subitemHistoryToolStripMenuItem_Click);
                historyToolStripMenuItem.DropDownItems.Add(tsmis[i]);
            }


        }

        private void subitemHistoryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (checkBoxNotifySave.Checked)
            {
                if (notifySaveAnd("continue?") == DialogResult.No)
                {
                    return;
                }
            }

            ToolStripMenuItem tsmi = (ToolStripMenuItem)sender;

            rootFolder = tsmi.Text;
            labelRootFolder.Text = rootFolder;
            prepare();
            //historyAdd(rootFolder);
            historyLoadAndSet();
        }

        private void historyAdd(string addPath)
        {
            string exePath = Application.StartupPath;
            string historyFileName = exePath + Path.DirectorySeparatorChar.ToString() + FormPMS.HistoryFileName;

            if (!File.Exists(historyFileName))
            {
                // 強制的に作る。
                string s = "";
                using (StreamWriter sw = new StreamWriter(historyFileName, false, USE_ENCODING))
                {
                    sw.Write(s);
                }
            }

            RichTextBox rtb = new RichTextBox();
            using(StreamReader sr = new StreamReader(historyFileName,USE_ENCODING))
            {
                rtb.Text = sr.ReadToEnd();
            }
            string[] lines = rtb.Lines;
            string newPath = addPath;
            foreach (string s in lines)
            {
                if (s == newPath)
                {
                    newPath = FormPMS.EmptyText;
                    break;
                }
            }
            if(newPath != FormPMS.EmptyText)
            {
                rtb.Text +=  Environment.NewLine;
                rtb.Text += newPath;
                using(StreamWriter sw = new StreamWriter(historyFileName, false, USE_ENCODING))
                {
                    sw.Write(rtb.Text);
                }
            }

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void copyLayer1AfterSelectedItemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!B_ACTIVE)
            {
                MessageBox.Show("not active", "error");
                return;
            }

            b_filecopying = true;

            try
            {
                string newFileName = getNewFileName("_copyL1");
                string from1 = rootFolder + Path.DirectorySeparatorChar.ToString() + listBox1.SelectedItem.ToString();
                string to1 = rootFolder + Path.DirectorySeparatorChar.ToString() + newFileName;
                fileCopy(from1, to1);
                orderfileAndListboxUpdate(newFileName);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
            finally
            {
                b_filecopying = false;
            }
        }

        private void copyLayer123tAfterSelectedItemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!B_ACTIVE)
            {
                MessageBox.Show("not active", "error");
                return;
            }

            b_filecopying = true;

            try
            {
                string newFileName = getNewFileName("_copyL123T");
                string from1 = rootFolder + Path.DirectorySeparatorChar.ToString() + listBox1.SelectedItem.ToString();
                string to1 = rootFolder + Path.DirectorySeparatorChar.ToString() + newFileName;
                fileCopy(from1, to1);
                {
                    string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
                    string filename = listBox1.SelectedItem.ToString();
                    
                    string from2 = subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer2Ex;
                    string to2 = subFolder + Path.DirectorySeparatorChar.ToString() + newFileName + FormPMS.Layer2Ex;
                    if(File.Exists(from2))
                        fileCopy(from2, to2);
                    
                    string from3 = subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.Layer3Ex;
                    string to3 = subFolder + Path.DirectorySeparatorChar.ToString() + newFileName + FormPMS.Layer3Ex;
                    if(File.Exists(from3))                    
                        fileCopy(from3, to3);
                    
                    string fromT = subFolder + Path.DirectorySeparatorChar.ToString() + filename + FormPMS.MemoTextEx;
                    string toT = subFolder + Path.DirectorySeparatorChar.ToString() + newFileName + FormPMS.MemoTextEx;
                    if(File.Exists(fromT))                    
                        fileCopy(fromT, toT);
                }
                orderfileAndListboxUpdate(newFileName);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
            finally
            {
                b_filecopying = false;
            }
        }

        private string getNewFileName(string addString)
        {
            string str = "";

            string selectedItem = listBox1.SelectedItem.ToString();
            int lastDotIndex;
            try
            {
                lastDotIndex = selectedItem.LastIndexOf('.');
            }
            catch (Exception exc)
            {
                throw exc;
            }
            string defaultNew = selectedItem.Substring(0, lastDotIndex) + addString;

            GetNewFileNameDialog gnfnd = new GetNewFileNameDialog(this.listBox1.Font, selectedItem,defaultNew);
            gnfnd.ShowDialog(this);
            if (gnfnd.DialogResult == DialogResult.OK)
            {
                str = gnfnd.Text;
            }
            else
            {
                throw new Exception("Canceled by user");
            }
            if (str == FormPMS.EmptyText)
            {
                throw new Exception("file name empty");
            }

            str += selectedItem.Substring(lastDotIndex);
            return str;
        }

        private void fileCopy(string fromFullpath, string toFullpath)
        {
            if (!File.Exists(fromFullpath))
                throw new Exception(string.Format("file not exist : {0}", fromFullpath));

            if (File.Exists(toFullpath))
                throw new Exception(string.Format("file allready exist : {0}", toFullpath));

            try
            {
                File.Copy(fromFullpath, toFullpath, false);
            }
            catch (Exception exc)
            {
                throw exc;
            }

            // toFullpath exist
            File.SetLastWriteTime(toFullpath, DateTime.Now);    

        }

        private void orderfileAndListboxUpdate(string newFileName)
        {
            string subFolder = rootFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.SubFolder;
            string orderFile = subFolder + Path.DirectorySeparatorChar.ToString() + FormPMS.OrderTextFileName;

            int index = listBox1.SelectedIndex;
            
            RichTextBox rtb = new RichTextBox();
            using (StreamReader sr = new StreamReader(orderFile, USE_ENCODING))
            {
                rtb.Text = sr.ReadToEnd();
            }
            string str = rtb.Text.Replace(
                listBox1.SelectedItem.ToString(),
                listBox1.SelectedItem.ToString() + Environment.NewLine + newFileName);
            using (StreamWriter sw = new StreamWriter(orderFile,false,USE_ENCODING))
            {
                sw.Write(str);
            }
            listboxRefresh();

            listBox1.SelectedIndex = index;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textboxTextObserverToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormTextObserver fto = new FormTextObserver(this.textBox1.Font, this.textBox1.Text);
            this.TextboxTextChangedEvent += new TextboxTextChangedEventDelegate(fto.formPMS_TextboxTextChanged);
            fto.Show();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void checkBoxListboxEnabled_CheckedChanged(object sender, EventArgs e)
        {
            listBox1.Enabled = checkBoxListboxEnabled.Checked;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        private DialogResult notifySaveAnd(string str)
        {
            if (!B_L2C && !B_L3C && !B_TC)
            {
                return DialogResult.OK;
            }

            DialogResult result = MessageBox.Show(
                "something changed." + Environment.NewLine + str, 
                "confirm", 
                MessageBoxButtons.YesNo,
                MessageBoxIcon.Question,
                MessageBoxDefaultButton.Button2);
            return result;
        }

        private void FormPMS_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (checkBoxNotifySave.Checked)
            {
                if (notifySaveAnd("close?") == DialogResult.No)
                {
                    e.Cancel = true;
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonPrintScreenPicturebox_Click(object sender, EventArgs e)
        {
            if (pictureBox1.Width < 1 || pictureBox1.Height < 1)
            {
                MessageBox.Show("size error");
                return;
            }

            Bitmap bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics g = Graphics.FromImage(bmp);

            Point p = pictureBox1.PointToScreen(new Point(0, 0));
            g.CopyFromScreen(p, new Point(0, 0), bmp.Size);
            Clipboard.SetDataObject(bmp);

            g.Dispose();
            //bmp.Dispose();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void trackBarZoom_Scroll(object sender, EventArgs e)
        {
            radioButtonZoom50.Checked = false;
            radioButtonZoom75.Checked = false;
            radioButtonZoom100.Checked = false;
            radioButtonZoom150.Checked = false;
            radioButtonZoom200.Checked = false;

            d_zoom = trackBarZoom.Value / 100.0;
            zoomApplyPictureboxSize();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseEnter(object sender, EventArgs e)
        {
            if (B_ACTIVE)
            {
                double d = pensize * d_zoom;
                if (1.0 <= d && d <= 8.0)
                    pictureBox1.Cursor = n8c;
                else if (8.0 < d && d <= 16.0)
                    pictureBox1.Cursor = n16c;
                else if (16.0 < d && d <= 32.0)
                    pictureBox1.Cursor = n32c;
                else
                    pictureBox1.Cursor = Cursors.Arrow;
            }
            else
            {
                pictureBox1.Cursor = Cursors.Arrow;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonFindDaysAgo_Click(object sender, EventArgs e)
        {
            if (rootFolder == FormPMS.EmptyText)
            {
                MessageBox.Show("select folder before use this", "error");
                return;
            }

            FormSearch fs = new FormSearch(rootFolder, Extensions,this);
            fs.FormSearchFindEvent += new FormSearchFindEventDelegate(fs_FormSearchFindEvent);
            fs.Show();
        }

        void fs_FormSearchFindEvent(string[] fullPahts)
        {
            B_ACTIVE = false;
            listBox1.Items.Clear();
            if (fullPahts.Length == 0)
            {
                return;
            }
            else
            {
                for (int i = 0; i < fullPahts.Length; i++)
                {
                    listBox1.Items.Add(Path.GetFileName(fullPahts[i]));
                }
            }

        }

        public string getRootFolderPath()
        {
            return this.rootFolder;
        }
    }
}
